/* GCC */

#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;

typedef long long ll;
typedef pair < ll, ll > pll;

vector < vector < ll > > l, d;
vector < vector < bool > > used;
vector < vector < char > > path;
vector < char > ch;
ll is, js, m, n;

bool edge(ll x, ll y)
{
    if (x == 0 || x == m - 1 || y == 0 || y == n - 1) return true;
    return false;
}

ll bfs(pll p)
{
    queue < pll > q;
    q.push(p);
    used [p.f][p.s] = true;
    if (edge(p.f, p.s)) return 0;
    while (!q.empty())
    {
        pll v = q.front();
        q.pop();
        ll i = v.f, j = v.s;
        if (edge(i, j))
        {
            is = i;
            js = j;
            return d [i][j];
        }
        if (!used [i - 1][j] && l [i - 1][j] == 1)
        {
            q.push({i - 1, j});
            used [i - 1][j] = true;
            d [i - 1][j] = d [i][j] + 1;
            path [i - 1][j] = 'n';
        }
        if (!used [i + 1][j] && l [i + 1][j] == 1)
        {
            q.push({i + 1, j});
            used [i + 1][j] = true;
            d [i + 1][j] = d [i][j] + 1;
            path [i + 1][j] = 's';
        }
        if (!used [i][j - 1] && l [i][j - 1] == 1)
        {
            q.push({i, j - 1});
            used [i][j - 1] = true;
            d [i][j - 1] = d [i][j] + 1;
            path [i][j - 1] = 'w';
        }
        if (!used [i][j + 1] && l [i][j + 1] == 1)
        {
            q.push({i, j + 1});
            used [i][j + 1] = true;
            d [i][j + 1] = d [i][j] + 1;
            path [i][j + 1] = 'e';
        }
    }
    return -1LL;
}

int main()
{
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);

    ll i1, j1;
    cin >> m >> n;
    cin.ignore();
    l.resize(m);
    d.resize(m);
    used.resize(m);
    path.resize(m);
    for (ll i = 0; i < m; ++i)
    {
        string s;
        getline(cin, s);
        while (s.size() < n) s = s + ' ';
        l [i].resize(n);
        d [i].resize(n, 0);
        used [i].resize(n, false);
        path [i].resize(n);
        for (ll j = 0; j < n; ++j)
        {
            if (s [j] == ' ')
            {
                l [i][j] = 1;
            }
            else if (s [j] == '+')
            {
                l [i][j] = 1;
                i1 = i;
                j1 = j;
            }
            else l [i][j] = 0;
        }
    }
    ll bfs1 = bfs({i1, j1});
    cout << bfs1 << '\n';
    if (bfs1 == 0 || bfs1 == -1LL) return 0;
    ll i = is, j = js;
    while (true)
    {
        char c = path [i][j];
        ch.push_back(c);
        if (c == 'n') ++i;
        if (c == 's') --i;
        if (c == 'w') ++j;
        if (c == 'e') --j;
        if (i == i1 && j == j1) break;
    }
    reverse(ch.begin(), ch.end());
    for (ll i = 0; i < ch.size(); ++i)
    {
        cout << ch [i];
    }
    cout << '\n';
}
