#include<algorithm>
#include<iostream>
#include<cstdio>
#include<queue>
#define point pair<int, int>
#define x first
#define y second

using namespace std;

int n, m;
string str, ans;
bool **arr;
point **from;
point start;

bool is_end(int i, int j){
    return (i == 0 || i == n-1 || j == 0 || j == m-1);
}

int main(){
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m;
    arr = new bool*[n];
    from = new point*[n];
    for(int i = 0; i < n; ++i){
        arr[i] = new bool[m];
        from[i] = new point[m];
    }
    getline(cin, str);
    for(int i = 0; i < n; ++i){
        getline(cin, str);
        for(int j = 0; j < m; ++j){
            from[i][j] = point(-1, -1);
            if(j < str.size()){
                if(str[j] == '+')
                    start = point(i, j);
                if(str[j] == ' ' || str[j] == '+')
                    arr[i][j] = false;
                else
                    arr[i][j] = true;
            }
            else arr[i][j] = false;
        }
    }
    if(is_end(start.x, start.y)){
        cout << 0 << endl;
        return 0;
    }
    from[start.x][start.y] = start;
    queue<point> q;
    q.push(start);
    point finish = point(-1, -1);
    while(!q.empty()){
        point p = q.front();
        q.pop();
        int x, y;
        point new_p;
        x = p.x+1;
        y = p.y;
        new_p = point(x, y);
        if(!arr[x][y] && from[x][y].x == -1){
            from[x][y] = p;
            if(is_end(x, y)){
                finish = new_p;
                break;
            }
            q.push(new_p);
        }

        x = p.x-1;
        y = p.y;
        new_p = point(x, y);
        if(!arr[x][y] && from[x][y].x == -1){
            from[x][y] = p;
            if(is_end(x, y)){
                finish = new_p;
                break;
            }
            q.push(new_p);
        }

        x = p.x;
        y = p.y+1;
        new_p = point(x, y);
        if(!arr[x][y] && from[x][y].x == -1){
            from[x][y] = p;
            if(is_end(x, y)){
                finish = new_p;
                break;
            }
            q.push(new_p);
        }

        x = p.x;
        y = p.y-1;
        new_p = point(x, y);
        if(!arr[x][y] && from[x][y].x == -1){
            from[x][y] = p;
            if(is_end(x, y)){
                finish = new_p;
                break;
            }
            q.push(new_p);
        }
    }
    if(finish.x == -1){
        cout << -1 << endl;
        return 0;
    }
    point v = finish;
    while(v != start){
        point u = from[v.x][v.y];
        if(v.x == u.x+1)
            ans.push_back('s');
        if(v.x == u.x-1)
            ans.push_back('n');
        if(v.y == u.y+1)
            ans.push_back('e');
        if(v.y == u.y-1)
            ans.push_back('w');
        v = u;
    }
    reverse(ans.begin(), ans.end());
    cout << ans.size() << endl;
    cout << ans << endl;
}
