/* GCC */
#include<bits/stdc++.h>

using namespace std;

vector<vector<bool> > grid, used;
vector<vector<int> > pr;
int main() {
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    grid.resize(n, vector<bool>(m, false));
    used.resize(n, vector<bool>(m, false));
    pr.resize(n, vector<int>(m, 0));
    string s;
    getline(cin, s);
    int s_x, s_y;
    for(int i = 0;i < n;++i) {
        getline(cin, s);
        for(int j = 0;j < m;++j) {
            if(s[j] == ' ')
                grid[i][j] = true;
            else
            if(s[j] == '+') {
                s_x = j;
                s_y = i;
                grid[i][j] = true;
            }
        }
    }

    queue<pair<int, int> > q;
    int x, y;
    q.push(make_pair(s_x, s_y));
    used[s_y][s_x] = true;
    while(!q.empty()) {
        x = q.front().first;
        y = q.front().second;
        q.pop();
        if(x == 0 || y == 0 || x == m-1 || y == n-1) {
            string ans = "";
            while(pr[y][x]) {
                if(pr[y][x] == -2) {
                    ans += 'n';
                    y++;
                }
                else
                if(pr[y][x] == -1) {
                    ans += 'w';
                    x++;
                }
                else
                if(pr[y][x] == 1) {
                    ans += 'e';
                    x--;
                }
                else
                if(pr[y][x] == 2) {
                    ans += 's';
                    y--;
                }
            }
            if(!ans.empty()) {
                cout << ans.size() << '\n';
                reverse(ans.begin(), ans.end());
                cout << ans << '\n';
            }
            else
                cout << "0\n";
            return 0;
        }
        if(x > 0 && !used[y][x-1] && grid[y][x-1]) {
            used[y][x-1] = true;
            pr[y][x-1] = -1;
            q.push(make_pair(x-1, y));
        }
        if(y > 0 && !used[y-1][x] && grid[y-1][x]) {
            used[y-1][x] = true;
            pr[y-1][x] = -2;
            q.push(make_pair(x, y-1));
        }
        if(x < m-1 && !used[y][x+1] && grid[y][x+1]) {
            used[y][x+1] = true;
            pr[y][x+1] = 1;
            q.push(make_pair(x+1, y));
        }
        if(y < n-1 && !used[y+1][x] && grid[y+1][x]) {
            used[y+1][x] = true;
            pr[y+1][x] = 2;
            q.push(make_pair(x, y+1));
        }
    }
    cout << "-1\n";
	return 0;
}

