#include <bits/stdc++.h>

using namespace std;

int m, n, si, sj, ei = -1, ej = -1;
string s;
vector <string> p;
vector <vector <int> > a;
queue <pair<int,int> > q;

void bfs () {
    bool flag = true;
    q.push({si, sj});
    while (flag && !q.empty()) {
        pair<int, int> u = q.front();
        q.pop();
        int ui = u.first;
        int uj = u.second;
        if (a[ui + 1][uj] == 0) {
            a[ui + 1][uj] = a[ui][uj] + 1;
            q.push({ui+1, uj});
            if (ui + 1 == 0 || ui + 1 == m-1) {
                flag = false;
                ei = ui + 1;
                ej = uj;
            }
        }
        if (a[ui - 1][uj] == 0) {
            a[ui - 1][uj] = a[ui][uj] + 1;
            q.push({ui-1, uj});
            if (ui - 1 == 0 || ui - 1 == m-1) {
                flag = false;
                ei = ui - 1;
                ej = uj;
            }
        }
        if (a[ui][uj + 1] == 0) {
            a[ui][uj + 1] = a[ui][uj] + 1;
            q.push({ui, uj+1});
            if (uj + 1 == 0 || uj + 1 == n-1) {
                flag = false;
                ei = ui;
                ej = uj + 1;
            }
        }
        if (a[ui][uj - 1] == 0) {
            a[ui][uj-1] = a[ui][uj] + 1;
            q.push({ui, uj-1});
            if (uj - 1 == 0 || uj - 1 == m-1) {
                flag = false;
                ei = ui;
                ej = uj - 1;
            }
        }
    }
}

int main()
{
    freopen("labirint.in","r",stdin);
    freopen("labirint.out","w", stdout);
    vector <char> res;
    cin >> m >> n;
    cin.ignore();
    a.assign(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        getline(cin, s);
        p.push_back(s);
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            if (p[i][j] == ' ') a[i][j] = 0;
            else if (p[i][j] == '+') { a[i][j] = 1; si = i; sj = j; }
            else a[i][j] = -1;
        }
    }
    if ((si == 0 || si == m-1) || (sj == 0 || sj == n-1)) {
        cout << 0 << endl;
        return 0;
    }
    bfs();
    if (ei == -1 || ej == -1) {
        cout << -1 << endl;
        return 0;
    }
    cout << a[ei][ej]-1 << endl;
    int k = a[ei][ej];
    while (ei != si || ej != sj) {
        if(ei+1 < m) {
            if (a[ei+1][ej] == k-1) {
                res.push_back('n');
                ei++;
            }
        }
        if(ei > 0) {
            if (a[ei-1][ej] == k-1) {
                res.push_back('s');
                ei--;
            }
        }
        if (ej + 1 < n) {
            if (a[ei][ej+1] == k-1) {
                res.push_back('w');
                ej++;
            }
        }
        if (ej > 0) {
            if (a[ei][ej-1] == k-1) {
                res.push_back('e');
                ej--;
            }
        }
        k--;
    }
    for (int i = res.size()-1; i>-1; i--) cout << res[i];
    cout << endl;
    return 0;
}
