#include <bits/stdc++.h>

using namespace std;

vector<vector<char> > in;
vector<vector<int> > f;
int n, m;
pair<int, int> start;

void readData(){
    scanf("%d %d", &n, &m);
    f.resize(n, vector<int>(m, 1000000));
    in.resize(n, vector<char>(m, ' '));
    for (int i = 0; i < n; i++){
        char c = getchar();
        for (int j = 0; j < m; j++){
            c = getchar();
            if (c == '+'){
                start = make_pair(i, j);
            } else if (c != ' '){
                in[i][j] = '#';
            }
        }
    }
}

void solve(){
    queue<pair<int, int> > q;
    for (int i = 0; i < n; i++){
        if (in[i][0] != '#'){
            f[i][0] = 0;
            q.push(make_pair(i, 0));
        }
        if (in[i][m-1] != '#'){
            f[i][m-1] = 0;
            q.push(make_pair(i, m-1));
        }
    }
    for (int i = 1; i < m-1; i++){
        if (in[0][i] != '#'){
            f[0][i] = 0;
            q.push(make_pair(0, i));
        }
        if (in[n-1][i] != '#'){
            f[n-1][i] = 0;
            q.push(make_pair(n-1, i));
        }
    }

    while (!q.empty()){
        pair<int, int> z = q.front();
        q.pop();
        if (z == start){
            break;
        }
        int x = z.first, y = z.second;
        if (x > 0 && in[x-1][y] != '#' && f[x-1][y] > f[x][y]+1){
            f[x-1][y] = f[x][y] + 1;
            q.push(make_pair(x-1, y));
        }
        if (x < n-1 && in[x+1][y] != '#' && f[x+1][y] > f[x][y]+1){
            f[x+1][y] = f[x][y] + 1;
            q.push(make_pair(x+1, y));
        }
        if (y > 0 && in[x][y-1] != '#' && f[x][y-1] > f[x][y]+1){
            f[x][y-1] = f[x][y] + 1;
            q.push(make_pair(x, y-1));
        }
        if (y < m-1 && in[x][y+1] != '#' && f[x][y+1] > f[x][y]+1){
            f[x][y+1] = f[x][y] + 1;
            q.push(make_pair(x, y+1));
        }
    }
}

void fileOut(){
    int x = start.first, y = start.second;
    if (f[x][y] == 1000000){
        printf("-1\n");
        return;
    }
    printf("%d\n", f[x][y]);
    int left = f[x][y];
    if (left == 0) return;
    while (left > 0){
        if (x > 0 && in[x-1][y] != '#' && f[x-1][y]+1==f[x][y]){
            printf("n");
            x--;
            left--;
        }
        if (x < n-1 && in[x+1][y] != '#' && f[x+1][y]+1==f[x][y]){
            printf("s");
            x++;
            left--;
        }
        if (y > 0 && in[x][y-1] != '#' && f[x][y-1]+1==f[x][y]){
            printf("w");
            y--;
            left--;
        }
        if (y < m-1 && in[x][y+1] != '#' && f[x][y+1]+1==f[x][y]){
            printf("e");
            y++;
            left--;
        }
    }
    printf("\n");
}

int main(){
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);
    readData();
    solve();
    fileOut();
    fclose(stdin);
    fclose(stdout);
    return 0;
}










































