#include <bits/stdc++.h>
#define A first
#define D second

using namespace std;
typedef vector<int> big;

vector<pair<int, int> > prog;
vector<int> a, c, d, k;
bool flag = false;
int n, first;

big operator+(big a, int c){
    big b(1, c);
    int carry = 0;
    for (unsigned int i = 0; carry || i < a.size(); i++){
        if (i == a.size()) a.push_back(0);
        long long curr = a[i] + carry + (i < b.size() ? b[i] : 0);
        carry = curr/1000;
        a[i] = curr%1000;
    }
    while (a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}

big operator*(big a, int b){
    int carry = 0;
    for (unsigned int i = 0; carry || i < a.size(); i++){
        if (i == a.size()) a.push_back(0);
        long long curr = carry + a[i]*b;
        carry = curr/1000;
        a[i] = curr%1000;
    }
    while (a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}

int gcd(int a, int b){
    return b == 0 ? a : gcd(b, a%b);
}

void readData(){
    scanf("%d", &n);
    int a1, d1;
    for (int i = 0; i < n; i++){
        scanf("%d%d", &a1, &d1);
        prog.push_back(make_pair(a1, d1));
        if (d1 == 0){
            flag = true;
            first = a1;
        }
    }
}

void fileOut(){
    if (flag){
        for (int i = 0; i < n && flag; i++){
            if (prog[i].D == 0){
                flag = (first == prog[i].A);
            } else {
                flag = ((first >= prog[i].A) &&((first - prog[i].A)%prog[i].D == 0));
            }
        }
        if (flag){
            printf("%d\n", first);
        } else {
            printf("0\n");
        }
    } else {
        sort(prog.begin(), prog.end());
        a = c = d = k = vector<int>(n);
        for (int i = 0; i < n; i++){
            a[i] = prog[prog.size()-i-1].A;
            d[i] = prog[prog.size()-i-1].D;
        }
        c[0] = d[0];
        k[n-1] = 0;
        for (int curr = 0; curr < n-1; curr++){
            int next = curr+1;
            c[next] = d[next];
            for (int i = curr; i >= 0; i--){
                c[next] /= gcd(c[next], d[i]);
            }
            int currMod = 0;
            int currD = d[next]/c[next];
            for (int i = curr-1; i >= 0; i--){
                currMod = (c[i] * (currMod + k[i]))%currD;
            }
            currMod = (currMod + a[0] - a[next])%currD;
            if (currMod){
                printf("0\n");
                return;
            }
            currMod = 0;
            currD = c[curr];
            for (int i = curr-1; i >= 0; i--){
                currD = (c[i] * currD)%d[next];
                currMod = (c[i] * (currMod + k[i]))%d[next];
            }
            currMod = (currMod + a[0] - a[next])%d[next];
            k[curr] = 0;
            while (currMod){
                currMod = (currMod + currD)%d[next];
                k[curr]++;
            }
        }
        big ans(1, 0);
        for (int i = c.size()-1; i >= 0; i--){
            ans = (ans + k[i]) * c[i];
        }
        ans = ans + a[0];
        printf("%d", ans.back());
        for (int i = ans.size()-2; i >= 0; i--){
            printf("%03d", ans[i]);
        }
        printf("\n");
    }
}

int sti(string s){
    int x = 0;
    for (int i = 0; i < (int)s.size(); i++){
        x *= 10;
        x += s[i] - '0';
    }
    return x;
}

int main(){
    freopen("common.in", "r", stdin);
    freopen("common.out", "w", stdout);
    readData();
    fileOut();
    fclose(stdin);
    fclose(stdout);
    return 0;
}


















